Subject: Re: [PATCH net-next 0/5] net: Improve netns handling in RTNL and ip_tunnel

From: Jakub Kicinski <[email-masked]>
Date: Wed, 30 Oct 2024 16:35:04 -0700

On Wed, 30 Oct 2024 10:10:32 +0800 Xiao Liang wrote:
> > Do you think the netns_atomic module param is really necessary?
> > I doubt anyone cares about the event popping up in the wrong
> > name space first.  
> 
> We used FRRouting in our solution which listens to link notifications to
> set up corresponding objects in userspace. Since the events are sent
> in different namespaces (thus via different RTNL sockets), we can't
> guarantee that the events are received in the correct order, and have
> trouble processing them. The way to solve this problem I can think of is
> to have a multi-netns RTNL socket where all events are synchronized,
> or to eliminate the redundant events in the first place. The latter seems
> easier to implement.

I think we're on the same page. I'm saying that any potential user 
will run into a similar problem, and I don't see a clear use case 
for notifications in both namespaces. So we can try to make the
behavior of netns_atomic=1 the default one and get rid of the module
param.